const ovpns = [
  { title: "Canada_proxy", file: "Canada_proxy.ovpn" },
  { title: "Canada_TCP", file: "Canada_TCP.ovpn" },
  { title: "Canada_UDP", file: "Canada_UDP.ovpn" },
  { title: "Czech_Republic_proxy", file: "Czech_Republic_proxy.ovpn" },
  { title: "Czech_Republic_TCP", file: "Czech_Republic_TCP.ovpn" },
  { title: "Czech_Republic_UDP", file: "Czech_Republic_UDP.ovpn" },
  { title: "England_proxy", file: "England_proxy.ovpn" },
  { title: "England_TCP", file: "England_TCP.ovpn" },
  { title: "England_UDP", file: "England_UDP.ovpn" },
  { title: "France_proxy", file: "France_proxy.ovpn" },
  { title: "France_TCP", file: "France_TCP.ovpn" },
  { title: "France_UDP", file: "France_UDP.ovpn" },
  { title: "Germany_proxy", file: "Germany_proxy.ovpn" },
  { title: "Germany_TCP", file: "Germany_TCP.ovpn" },
  { title: "Germany_UDP", file: "Germany_UDP.ovpn" },
  { title: "Netherlands_proxy", file: "Netherlands_proxy.ovpn" },
  { title: "Netherlands_TCP", file: "Netherlands_TCP.ovpn" },
  { title: "Netherlands_UDP", file: "Netherlands_UDP.ovpn" },
  { title: "USA_proxy", file: "USA_proxy.ovpn" },
  { title: "USA_TCP", file: "USA_TCP.ovpn" },
  { title: "USA_UDP", file: "USA_UDP.ovpn" }
];

const pptps = [
  { title: "us", server: "us.vpadd.com" },
  { title: "uk", server: "uk.vpadd.com" },
  { title: "nl", server: "nl.vpadd.com" },
  { title: "ca", server: "ca.vpadd.com" },
  { title: "fr", server: "fr.vpadd.com" },
  { title: "de", server: "de.vpadd.com" },
  { title: "cz", server: "cz.vpadd.com" }
];

const cisco_vpns = [
  { title: "main_us", server: "us5.cisadd2.com" },
  { title: "main_uk", server: "uk.cisadd2.com" },
  { title: "main_nl", server: "nl.cisadd2.com" },
  { title: "main_ca", server: "ca.cisadd2.com" },
  { title: "main_fr", server: "fr.cisadd2.com" },
  { title: "main_de", server: "de.cisadd2.com" },
  { title: "main_cz", server: "cz.cisadd2.com" },
  { title: "alt_us", server: "us.nexpadd.com" },
  { title: "alt_uk", server: "uk.nexpadd.com" },
  { title: "alt_nl", server: "nl.nexpadd.com" },
  { title: "alt_ca", server: "ca.nexpadd.com" },
  { title: "alt_fr", server: "fr.nexpadd.com" },
  { title: "alt_de", server: "de.nexpadd.com" },
  { title: "alt_cz", server: "cz.nexpadd.com" },
  { title: "us[800]", server: "us2.cisadd3.com:800" },
  { title: "uk[800]", server: "uk.cisadd3.com:800" },
  { title: "nl[800]", server: "nl.cisadd3.com:800" },
  { title: "ca[800]", server: "ca.cisadd3.com:800" },
  { title: "fr[800]", server: "fr.cisadd3.com:800" },
  { title: "de[800]", server: "de.cisadd3.com:800" },
  { title: "cz[800]", server: "cz.cisadd3.com:800" }
];

const GLib = imports.gi.GLib;
const ExtensionUtils = imports.misc.extensionUtils;
const CurrExtension = ExtensionUtils.getCurrentExtension();

const shell_path = CurrExtension.path + "/sh";
const vpn_path = CurrExtension.path + "/vpns";

const St = imports.gi.St;
const Util = imports.misc.util;

const Clutter = imports.gi.Clutter;

const Main = imports.ui.main;
const ModalDialog = imports.ui.main.ModalDialog;
const PanelMenu = imports.ui.panelMenu;
const PopupMenu = imports.ui.popupMenu;

const Lang = imports.lang;

const PopupMenuExample = new Lang.Class({
  Name: "PopupMenuExample", // Class Name
  Extends: PanelMenu.Button, // Parent Class

  // Constructor
  _init: function() {
    this.parent(1, "PopupMenuExample", false);
    // We are creating a box layout with shell toolkit
    let box = new St.BoxLayout();

    let icon = new St.Icon({
      icon_name: "preferences-system-network",
      style_class: "system-status-icon"
    });

    // A label expanded and center aligned in the y-axis
    let toplabel = new St.Label({
      text: " VM ",
      y_expand: true,
      y_align: Clutter.ActorAlign.CENTER
    });

    // We add the icon, the label and a arrow icon to the box
    box.add(icon);
    box.add(toplabel);
    // box.add(PopupMgnomeenu.arrowIcon(St.Side.BOTTOM));

    // We add the box to the button
    // It will be showed in the Top Panel
    this.actor.add_child(box);

    // Add OpenVpns to menu
    let popupMenuExpander = new PopupMenu.PopupSubMenuMenuItem("OpenVpn");
    ovpns.forEach(vpn => {
      const submenuItem = new PopupMenu.PopupMenuItem(vpn.title);
      submenuItem.connect(
        "activate",
        Lang.bind(this, function() {
          this.connectVPN(function(u, p) {
            Util.spawn([
              "bash",
              `${shell_path}/connect.sh`,
              vpn_path + "/" + vpn.file,
              u,
              p
            ]);
          });
        })
      );
      popupMenuExpander.menu.addMenuItem(submenuItem);
    });

    // add PPTP to menu
    let PPTPExpander = new PopupMenu.PopupSubMenuMenuItem("PPTP");
    pptps.forEach(vpn => {
      const submenuItem = new PopupMenu.PopupMenuItem(vpn.title);
      submenuItem.connect(
        "activate",
        Lang.bind(this, function() {
          this.connectVPN(function(u, p) {
            Util.spawn(["bash", `${shell_path}/pptp.sh`, vpn.server, u, p]);
          });
        })
      );
      PPTPExpander.menu.addMenuItem(submenuItem);
    });
    // add Cisco to menu
    let CiscoExpander = new PopupMenu.PopupSubMenuMenuItem("Cisco");
    cisco_vpns.forEach(vpn => {
      const submenuItem = new PopupMenu.PopupMenuItem(vpn.title);
      submenuItem.connect(
        "activate",
        Lang.bind(this, function() {
          this.connectVPN(function(u, p) {
            Util.spawn([
              "x-terminal-emulator",
              "-e",
              "bash",
              `${shell_path}/cisco.sh`,
              vpn.server,
              u,
              p
            ]);
          });
        })
      );
      CiscoExpander.menu.addMenuItem(submenuItem);
    });

    // This is an example of PopupMenuItem, a menu item. We will use this to add as a submenu

    // A new label
    // let label = new St.Label({ text: "Item 1" });
    // popupMenuExpander.menu.box.add(label);

    // The CSS from our file is automatically imported
    // You can add custom styles like this
    // REMOVE THIS AND SEE WHAT HAPPENS
    popupMenuExpander.menu.box.style_class = "PopupSubMenuMenuItemStyle";

    // Other standard menu items
    let removeCredentials = new PopupMenu.PopupMenuItem("remove credentials");
    let switchmenuitem = new PopupMenu.PopupSwitchMenuItem(
      "PopupSwitchMenuItem"
    );
    let imagemenuitem = new PopupMenu.PopupImageMenuItem(
      "PopupImageMenuItem",
      "system-search-symbolic"
    );

    removeCredentials.connect(
      "activate",
      Lang.bind(this, function() {
        Util.spawn(["secret-tool", "clear", "extension", "vpnmakers"]);
      })
    );
    // Assemble all menu items
    this.menu.addMenuItem(popupMenuExpander);
    this.menu.addMenuItem(PPTPExpander);
    this.menu.addMenuItem(CiscoExpander);
    this.menu.addMenuItem(removeCredentials);
    // This is a menu separator
    // this.menu.addMenuItem(new PopupMenu.PopupSeparatorMenuItem());
    // this.menu.addMenuItem(menuitem);
    // this.menu.addMenuItem(new PopupMenu.PopupSeparatorMenuItem());
    // this.menu.addMenuItem(switchmenuitem);
    // this.menu.addMenuItem(new PopupMenu.PopupSeparatorMenuItem());
    // this.menu.addMenuItem(imagemenuitem);

    // switchmenuitem.connect(
    //   "toggled",
    //   Lang.bind(this, function(object, value) {
    //     // We will just change the text content of the label
    //     if (value) {
    //       label.set_text("On");
    //     } else {
    //       label.set_text("Off");
    //     }
    //   })
    // );

    this.menu.connect(
      "open-state-changed",
      Lang.bind(this, function(prop) {
        log(Object.keys(prop));
        if (prop.isOpen) {
          popupMenuExpander.setSubmenuShown(true);
        }
      })
    );
  },

  destroy: function() {
    this.parent();
  },
  connectVPN: function(callback) {
    // check if username is exist in keyring
    let query_username = "secret-tool search extension vpnmakers";
    let u = GLib.spawn_command_line_sync(query_username)[1].toString();
    let l = u.split("\n");
    let dict = {};
    l.forEach(element => {
      let ll = element.split(" = ");
      dict[ll[0]] = ll[1];
    });
    log("dic", dict.label, dict.secret);
    if (dict.label && dict.secret) {
      callback(dict.label, dict.secret);
      return;
    }

    // no username and password, get from input
    let diag = new ModalDialog.ModalDialog();
    diag.set_style("dialog");

    let username = new St.Entry({
      style_class: "inputLabel",
      "hint-text": "Username"
    });
    let password = new St.Entry({
      style_class: "inputLabel",
      "hint-text": "Password"
    });
    let w = new St.Label({
      text: "Please fill out the username and password ",
      style_class: "dialogLabel"
    });
    diag.dialogLayout.addContent(w);
    diag.dialogLayout.addContent(username);
    diag.dialogLayout.addContent(password);
    let close_buttons = [
      {
        label: "Ok",
        action: function() {
          diag.close();
          const u = username.get_text();
          const p = password.text;
          save_query =
            "echo -n '" +
            p +
            "' | secret-tool store --label '" +
            u +
            "' extension vpnmakers";
          Util.spawn(["bash", "-c", `${save_query}`]);
          callback(u, p);
          Main.notify(u, p);
        }
      },
      {
        label: "Cancel",
        action: function() {
          diag.close();
        }
      }
    ];

    diag.setButtons(close_buttons);

    diag.open();
  }
});

let button;

function init() {}

function enable() {
  button = new PopupMenuExample();

  Main.panel.addToStatusArea("PopupMenuExample", button, 0, "right");
}

function disable() {
  button.destroy();
}
